#include <iostream>
#include <cstdlib>
#include <ctime>
#include <vector>

using namespace std;


struct dimensions {
	float h;
	float w;
	float d;
};

char wheels[3][27] = {
	"мотоциклетный",
	"автомобильный",
	"рычаги"
};

char h_eng[2][23] = {
	"отсутствует",
	"есть"
};
struct categ {
	bool a;
	bool b;
	bool c;
	bool d;
	bool be;
	bool ce;
	bool de;
};


// -------------------------TRANSPORT-------------------------------
class Transport{
public:
	Transport(){}

	Transport(int whel, int doors, bool eng, int whtype, int seats, int weig, int mweigh, float h, float w, float d){
		num_of_wheels = whel;
		num_of_doors = doors;
		has_engine = eng;
		wheel_type = whtype;
		num_of_seats = seats;
		weight = weig;
		max_weight = mweigh;
		dimens = {h, w, d};
	}

	void set(int whel, int doors, bool eng, int whtype, int seats, int weig, int mweigh, float h, float w, float d){
		num_of_wheels = whel;
		num_of_doors = doors;
		has_engine = eng;
		wheel_type = whtype;
		num_of_seats = seats;
		weight = weig;
		max_weight = mweigh;
		dimens = {h, w, d};
	}
	void print_transport(){
		cout << "Транстпорт: \n" 
			<< "    Кол-во колёс: " << num_of_wheels << endl 
			<< "    Кол-во дверей: " << num_of_doors << endl 
			<< "    Наличие двигателя: " << h_eng[has_engine] << endl 
			<< "    Тип руля: " << wheels[wheel_type] << endl 
			<< "    Мест для сидения: " << num_of_seats << endl 
			<< "    Масса: " << weight << endl 
			<< "    Максимальная масса: " << max_weight << endl 
			<< "    Габариты:\n       высота:" << dimens.h << endl
			<< "       ширина: " << dimens.w << endl 
			<< "       глубина: " << dimens.d << endl;
	}
private:
	
protected:
	int num_of_wheels = 0;
	int num_of_doors = 0;
	bool has_engine = 0;
	int wheel_type = 0;  // 0-мотоциклетный, 1-автомобильный, 3-рычаги
	int num_of_seats = 1;
	int weight = 1;
	int max_weight = 10;
	dimensions dimens = {1, 1, 1};
};


// ----------------------------CAR--------------------------------------
class Car: protected Transport{
public:
	Car(){
		_init(4, 2, 1, 1, 2, 400, 500, 1, 2.5, 3, "А111АА111", 0, 0);
	}
	Car(int whel, int doors, bool eng, int whtype, int seats, int weig, int mweigh, float h, float w, 
		float d, char *num, int pasp, int cert){
		_init(whel, doors, eng, whtype, seats, weig, mweigh, h, w, d, num, pasp, cert);
	}
	void set_car(int whel, int doors, bool eng, int whtype, int seats, int weig, int mweigh, float h, float w, 
		float d, char *num, int pasp, int cert){
		_init(whel, doors, eng, whtype, seats, weig, mweigh, h, w, d, num, pasp, cert);
	}
	void print_car(bool print_trans){
		if(print_trans){
			print_transport();
		}
		cout << "Автомобиль: \n" 
			<< "    Гос. номер: " << number << endl 
			<< "    ПТС: " << vehicle_passport << endl
			<< "    СТС: " << cert_of_reg << endl;
	}
private:

	void _init(int whel, int doors, bool eng, int whtype, int seats, int weig, int mweigh, float h, float w, 
		float d, char *num, int pasp, int cert){
		num_of_wheels = whel;
		num_of_doors = doors;
		has_engine = eng;
		wheel_type = whtype;
		num_of_seats = seats;
		weight = weig;
		max_weight = mweigh;
		dimens = {h, w, d};

		number = num;
		vehicle_passport = pasp;
		cert_of_reg = cert;
	}

protected:
	char *number = "А111АА111";
	int vehicle_passport = 0;
	int cert_of_reg = 0;
};


// ----------------------------DRIVER-------------------------------------
class Driver{
public:
	char *name = "";
	int age = 16;
	categ categories = {0, 0, 0, 0, 0, 0, 0};

	Driver(char* nm, int ag, int year_of_obt, int year_of_last){
		name = nm;
		age = ag;
		year_obtaining_dr_lic = year_of_obt;
		year_last_dr_lic_change = year_of_last;
	}
	Driver(){
		
	}
	~Driver(){

	}
	void set_driver(char* nm, int ag, int year_of_obt, int year_of_last){
		name = nm;
		age = ag;
		year_obtaining_dr_lic = year_of_obt;
		year_last_dr_lic_change = year_of_last;
	}
	void set_driver(char* nm, int ag){
		name = nm;
		age = ag;
	}
	void set_ctg(char *ctg, bool val){
		if (ctg == "a"){
			categories.a = val;
		}else if(ctg == "b"){
			categories.b = val;
		}else if(ctg == "c"){
			categories.c = val;
		}else if(ctg == "d"){
			categories.d = val;
		}else if(ctg == "be"){
			categories.be = val;
		}else if(ctg == "ce"){
			categories.ce = val;
		}else if(ctg == "de"){
			categories.de = val;
		}else{
			cout << "Неверный параметр: Такой категории нет.\n";
		}
	}
	void print_driver(){
		time_t now = time(0);
		tm *ltm = localtime(&now);
		int now_year = 1900 + ltm->tm_year;
		cout << "Водитель: \n    Имя: " << name << endl << "    Возраст: " << age << endl << 
		"    Стаж: " <<  now_year - year_obtaining_dr_lic << endl << "    Открытые категории: ";
		_show_ctgs();
	}
private:
	void _show_ctgs(){
		if(categories.a){
			cout << " A ";
		}
		if(categories.b){
			cout << " B ";
		}
		if(categories.c){
			cout << " C ";
		}
		if(categories.d){
			cout << " D ";
		}
		if(categories.be){
			cout << " BE ";
		}
		if(categories.ce){
			cout << " CE ";
		}
		if(categories.de){
			cout << " DE ";
		}
		cout << endl;
	}
protected:
	int year_obtaining_dr_lic = 1900;
	int year_last_dr_lic_change = 2000;
};


// --------------------------CAR_DRIVER-------------------------------------
class Car_Driver: public Driver, public Car{
public:
	Car_Driver(char* nm, int ag, int year_of_obt, int year_of_last){
		// car = cr;
		name = nm;
		age = ag;
		year_obtaining_dr_lic = year_of_obt;
		year_last_dr_lic_change = year_of_last;
	}
	Car_Driver(){

	}
	void print_car_driver(bool print_cr, bool print_dr){
		if(print_cr){
			print_car(1);
		}
		if(print_dr){
			print_driver();
		}
	}
private:

protected:
	// Car car;
};


// ------------------------OFFICIAL_CAR_DRIVER------------------------------
class Official_Car_Driver: protected Car_Driver{
public:
	char *company = "";
	Official_Car_Driver(char* nm, int ag, int year_of_obt, int year_of_last, char *comp){
		// car = cr;
		name = nm;
		age = ag;
		year_obtaining_dr_lic = year_of_obt;
		year_last_dr_lic_change = year_of_last;
		company = comp;
	}
	void set_company(char *comp){
		company = comp;
	}
	void print_off_car_driver(bool print_cr){
		print_car_driver(print_cr, 1);
		cout << "    Компания: " << company << endl;
	}
	void set_category(char *ctg, bool val){
		set_ctg(ctg, val);
	}
private:

protected:

};


// ------------------------TAXI_CAR_DRIVER------------------------------
class Taxi_Car_Driver: protected Car_Driver{
public:
	float rating = 0;
	int taxi_experience = 0;
	char *taxi_company = "";
	Taxi_Car_Driver(char* nm, int ag, int year_of_obt, int year_of_last, float rat, int exp, char *comp){
		// car = cr;
		name = nm;
		age = ag;
		year_obtaining_dr_lic = year_of_obt;
		year_last_dr_lic_change = year_of_last;
		rating = rat;
		taxi_experience = exp;
		taxi_company = comp;
	}
	void print_taxi_car_driver(bool print_cr){
		print_car_driver(print_cr, 1);
		cout << "    Рейтинг: " << rating << endl
		<< "    Стаж таксиста: " << taxi_experience << endl
		<< "    Таксопарк: " << taxi_company << endl;
	}
	void set_category(char *ctg, bool val){
		set_ctg(ctg, val);
	}
private:

protected:

};



// -------------------------------------MAIN-----------------------------
int main(){
	setlocale(LC_ALL, "ru_RU.utf8");

	// Transport tran;
	// tran.print_transport();

	Car car;
	car.set_car(4, 5, 1, 1, 5, 920, 1400, 1.2, 3, 4.6, "А320МС134", 1389462364, 856942357);
	// car.print_car(1);

	categ ctgs={0,1,0,0,1,0,0};
	char *nm = "Иван";
	Driver dr(nm, 25, 2016, 2012);
	// Driver dr;
	dr.set_ctg("b", 1);
	dr.set_ctg("be", 1);
	// dr.print_driver();

	Car_Driver cdr(nm, 25, 2018, 2013);
	cdr.set_ctg("a", 1);
	// cdr.print_car_driver(1, 1);

	Official_Car_Driver ocdr("Влад", 30, 2015, 2020, "S2 INK");
	ocdr.set_category("b", 1);
	ocdr.print_off_car_driver(0);

	Taxi_Car_Driver tcdr("Владимир", 30, 2015, 2020, 4.3, 2, "S2 INK");
	tcdr.set_category("b", 1);
	tcdr.print_taxi_car_driver(0);

	return 0;
}

